# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class ContentStorageInfo(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'storage_properties': 'dict(str, str)'
    }

    attribute_map = {
        'id': 'id',
        'storage_properties': 'storageProperties'
    }

    def __init__(self, id=None, storage_properties=None, _configuration=None):  # noqa: E501
        """ContentStorageInfo - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._storage_properties = None
        self.discriminator = None

        self.id = id
        if storage_properties is not None:
            self.storage_properties = storage_properties

    @property
    def id(self):
        """Gets the id of this ContentStorageInfo.  # noqa: E501

        Content type property identifier (e.g. cm:content). Inside this object only colon (':') delimiter for namespace-prefix will be used.   # noqa: E501

        :return: The id of this ContentStorageInfo.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ContentStorageInfo.

        Content type property identifier (e.g. cm:content). Inside this object only colon (':') delimiter for namespace-prefix will be used.   # noqa: E501

        :param id: The id of this ContentStorageInfo.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def storage_properties(self):
        """Gets the storage_properties of this ContentStorageInfo.  # noqa: E501

        A map (String-String) of storage properties for given content.   # noqa: E501

        :return: The storage_properties of this ContentStorageInfo.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._storage_properties

    @storage_properties.setter
    def storage_properties(self, storage_properties):
        """Sets the storage_properties of this ContentStorageInfo.

        A map (String-String) of storage properties for given content.   # noqa: E501

        :param storage_properties: The storage_properties of this ContentStorageInfo.  # noqa: E501
        :type: dict(str, str)
        """

        self._storage_properties = storage_properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ContentStorageInfo, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ContentStorageInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ContentStorageInfo):
            return True

        return self.to_dict() != other.to_dict()
